<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SyncExecutor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.executors.sync</a> &gt; <span class="el_source">SyncExecutor.java</span></div><h1>SyncExecutor.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.executors.sync;

import io.gitlab.littlesaints.protean.EventExecutor;
import io.gitlab.littlesaints.protean.Graph;
import io.gitlab.littlesaints.protean.analytics.StatsListener;
import io.gitlab.littlesaints.protean.configuration.ExecutorOptions;
import io.gitlab.littlesaints.protean.event.EventAccessor;
import io.gitlab.littlesaints.protean.resources.Registrar;
import lombok.extern.log4j.Log4j2;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.LongAdder;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;

/**
 * This is a Synchronous {@link EventExecutor}.
 * It uses the publisher thread to execute the configured graph stages i.e. the workflow, serially. There can be multiple publisher threads in the application.
 * It ignores setting for parallelism and concurrency at executor and node levels. There are other available executors that better fit the parallel execution requirements.
 *
 * @author Varun Anand
 * @since 1.0
 */
<span class="fc" id="L49">@Log4j2</span>
public class SyncExecutor&lt;E, P, R&gt; implements EventExecutor&lt;P, R&gt; {

    public static final String TYPE = &quot;protean::executor::sync&quot;;

<span class="fc" id="L54">    public static class _Registrar implements Registrar {</span>
        static {
<span class="fc" id="L56">            REGISTRY.register(TYPE, SyncExecutor::new);</span>
<span class="fc" id="L57">        }</span>

        @Override
        public String toString() {
<span class="fc" id="L61">            return &quot;SyncExecutor::Registrar&quot;;</span>
        }
    }

    private final Function&lt;P, R&gt; executeAction;
    private final Runnable shutdownAction;

    private SyncExecutor(final String contextName, final ExecutorOptions executorOptions, Supplier&lt;E&gt; constructor, final Graph&lt;E&gt; graph,
                         final BiConsumer&lt;E, P&gt; initializer, final Consumer&lt;E&gt; ackListener, final EventAccessor&lt;E, P&gt; eventAccessor,
<span class="fc" id="L70">                         final StatsListener&lt;E&gt; statsListener, final boolean cleanShutdown, final Function&lt;E, R&gt; resultMapper) {</span>

<span class="fc" id="L72">        final SyncExecutorConfigurer&lt;E&gt; eConfigurer = new SyncExecutorConfigurer&lt;&gt;(contextName, graph, statsListener, eventAccessor);</span>
<span class="fc" id="L73">        final Collection&lt;Runnable&gt; closeActions = Collections.synchronizedList(new ArrayList&lt;&gt;());</span>
<span class="fc" id="L74">        final Function&lt;E, E&gt; function = eConfigurer.configure(closeActions);</span>

        final Function&lt;E, E&gt; syncAckListener;
<span class="fc bfc" id="L77" title="All 2 branches covered.">        if (cleanShutdown) {</span>
<span class="fc" id="L78">            AtomicBoolean continueProcessing = new AtomicBoolean(true);</span>
<span class="fc" id="L79">            LongAdder inProcessingCounter = new LongAdder();</span>
<span class="fc" id="L80">            final Consumer&lt;E&gt; ackFx = ackListener.andThen(e -&gt; inProcessingCounter.decrement());</span>
<span class="fc" id="L81">            syncAckListener = event -&gt; {</span>
<span class="fc" id="L82">                ackFx.accept(event);</span>
<span class="fc" id="L83">                return event;</span>
            };
<span class="fc" id="L85">            final Function&lt;E, R&gt; execFx = function.andThen(syncAckListener).andThen(resultMapper);</span>
<span class="fc" id="L86">            executeAction = p -&gt; {</span>
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">                if (continueProcessing.get()) {</span>
<span class="fc" id="L88">                    inProcessingCounter.increment();</span>
<span class="pc bpc" id="L89" title="1 of 2 branches missed.">                    if (continueProcessing.get()) {</span>
<span class="fc" id="L90">                        E event = constructor.get();</span>
<span class="fc" id="L91">                        initializer.accept(event, p);</span>
<span class="fc" id="L92">                        return execFx.apply(event);</span>
                    } else {
<span class="nc" id="L94">                        inProcessingCounter.decrement();</span>
                    }
                } else {
<span class="nc bnc" id="L97" title="All 2 branches missed.">                    while (inProcessingCounter.sum() == 0) {</span>
<span class="nc" id="L98">                        Thread.yield();</span>
                    }
                }
<span class="nc" id="L101">                return null;</span>
            };
<span class="fc" id="L103">            shutdownAction = () -&gt; {</span>
<span class="fc" id="L104">                continueProcessing.lazySet(false);</span>
                //todo: get rid of processingCounter
//				continueProcessing.set(false);
<span class="pc bpc" id="L107" title="1 of 2 branches missed.">                while (inProcessingCounter.sum() != 0) {</span>
<span class="nc" id="L108">                    Thread.yield();</span>
                }
<span class="fc" id="L110">                closeActions.forEach(Runnable::run);</span>
<span class="fc" id="L111">            };</span>

<span class="fc" id="L113">        } else {</span>
<span class="fc" id="L114">            syncAckListener = e -&gt; {</span>
<span class="fc" id="L115">                ackListener.accept(e);</span>
<span class="fc" id="L116">                return e;</span>
            };
<span class="fc" id="L118">            final Function&lt;E, R&gt; execFx = function.andThen(syncAckListener).andThen(resultMapper);</span>
<span class="fc" id="L119">            executeAction = p -&gt; {</span>
<span class="fc" id="L120">                E event = constructor.get();</span>
<span class="fc" id="L121">                initializer.accept(event, p);</span>
<span class="fc" id="L122">                return execFx.apply(event);</span>
            };
<span class="pc" id="L124">            shutdownAction = () -&gt; closeActions.forEach(Runnable::run);</span>
        }
<span class="fc" id="L126">    }</span>

    @Override
    public R execute(final P payload) {
<span class="fc" id="L130">        return executeAction.apply(payload);</span>
    }

    @Override
    public void shutdown() {
<span class="fc" id="L135">        shutdownAction.run();</span>
<span class="fc" id="L136">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>